﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Wizard.UI;
using System.IO;
using Toub.MediaCenter.Dvrms.Metadata;
using System.Collections;

namespace DVRMS_Renamer
{
    public partial class wizPage6 : Wizard.UI.InternalWizardPage
    {
        private frmMain mobjOwnerForm;

        public wizPage6(frmMain OwnerForm)
        {
            InitializeComponent();

            mobjOwnerForm = OwnerForm;
        }

        private void wizPage6_WizardPageSetActive(object sender, System.ComponentModel.CancelEventArgs e)
        {
            SetWizardButtons(WizardButtons.Next);
        }

        private void wizPage6_WizardPageActivated(object sender, EventArgs e)
        {
            this.Refresh();
            FormLayout(Globals.FormLayouts.flProgress);
            Common.CheckForDuplicates(this, pgrProgress, lblWorking, lstItems);
            FormLayout(Globals.FormLayouts.flStandard);
        }

        private void wizPag6_Load(object sender, EventArgs e)
        {
            lstItems.FullRowSelect = true;
            lstItems.View = View.Details;
            lstItems.HeaderStyle = ColumnHeaderStyle.Nonclickable;
            lblWorking.Text = "Working...";

            ColumnHeader col1 = new ColumnHeader();

            col1.Text = "File";

            lstItems.Columns.AddRange(new ColumnHeader[] { col1 });
        }

        private void wizPage6_WizardNext(object sender, WizardPageEventArgs e)
        {
            Globals.selectedFilesToDelete.Clear();

            for (int i = 0; i < lstItems.CheckedItems.Count; i++)
            {
                File theFile = (File)lstItems.CheckedItems[i].Tag;
                Globals.selectedFilesToDelete.Add(theFile);
            }
        }

        private void FormLayout(Globals.FormLayouts fl)
        {
            lblWorking.Visible = (fl == Globals.FormLayouts.flProgress);
            pgrProgress.Visible = (fl == Globals.FormLayouts.flProgress);
            lstItems.Visible = (fl == Globals.FormLayouts.flStandard);

            if (fl == Globals.FormLayouts.flProgress)
            {
                Banner.Title = "Scanning";
                Banner.Subtitle = "Scanning your folders duplicate files";
            }
            else
            {
                Banner.Title = "Duplicate Check Results";
                Banner.Subtitle = "Here are the files which already exist in your target folder. You can choose which ones you want to delete";
            }
            this.Refresh();
        }
    }
}
